#Import fixes to make this Python 2.7 run the code more like Python 3.x
from __future__ import print_function, division

#Import VPython stuff:
from visual import *

#Define a function for printing out information about a vector-velocity
def printvel(v):
    print("The vector-velocity is ", v)
    # Compute the angle for the various possible quadrants:
    if(v[0]>0): # This is Quadrant 1 or 4
        theta=(180.0/math.pi)*arctan(v[1]/v[0]) 
    elif(v[0]==0):  # This is along the y-axis
        if(v[1]>0): # up
            theta=90.0 
        elif(v[1]==0): # zero speed, so let's just call theta 0
            theta=0.0
        else: # down
            theta=-90.0
    else:
        if(v[1]<0): #This is Quadrant 3
            theta=((180.0/math.pi)*arctan(v[1]/v[0]))-180.0 
        else: #This is Quadrant 2
            theta=180.0-((180.0/math.pi)*arctan(v1[1]/v1[0])) 
    print("The speed is ", mag(v), " m/s. ")
    print("The direction ", theta, \
          " degrees, measured counterclockwise from the x-axis.")
  
#Set up the window that will show the collision:
scene.height=800
scene.width=800
scene.range=(8,8,8)
scene.autoscale=0
scene.background=color.white

#Set the masses [in kg]:
m1=1.0
m2=4.0

#Set the radius of the balls [in m]:
r = 0.5

#Set the impact parameter [in m]:
# (Note this will be explained in Excersice C)
b = 0
if(b>=(2.0*r)):
    print("Ono, balls will not collide.")

# Set the initial position, radius and color of each ball
# [all distance units here are m]:
ball1=sphere(pos=(-4,b,0),radius=r, color=color.red)
ball2=sphere(pos=(0,0,0),radius=r, color=color.blue)

#Set the initial velocity x,y,z components of the two balls [in m/s]:
v1=vector(2,0,0)
v2=vector(-2,0,0)

#set the timestep [in s] and a counter to see if the balls have collided
# yet or not:
dt=0.05
collided=0

#start the motion, display each ball on the window:
while 1==1:
    rate(1/dt)
    ball1.pos=ball1.pos+v1*dt
    ball2.pos=ball2.pos+v2*dt

    # if a collision happens, then change the velocities:
    if ???Q2??? :
        collided=collided+1
        if collided==1:

            print("Before the collision:")
            print("Ball 1:")
            printvel(v1)
            print("Ball 2:")
            printvel(v2)
            print("The total vector-momentum of both balls is ", m1*v1+m2*v2, " Joules")
            print("The total kinetic energy of both balls is ", \
                  (m1*mag(v1)**2+m2*mag(v2)**2)/2, " Joules")

            #Update the post-collision velocities
            v1=???Q3???
            v2=v1

            print(" ")
            print("After the collision:")
            print("Ball 1:")
            printvel(v1)
            print("Ball 2:")
            printvel(v2)
            print("The total vector-momentum of both balls is ", m1*v1+m2*v2, " Joules")
            print("The total kinetic energy of both balls is ", \
                  (m1*mag(v1)**2+m2*mag(v2)**2)/2, " Joules")

